
    ;;#0FAF(4015) — Border. Цвет бордера.
     
    ;---------------------------------------
    ; TSConf examples
    ; (C) breeze/fishbone crew 2013
    ;---------------------------------------
     
            DEVICE ZXSPECTRUM128
     
     
     org $4000
    basb:
     inchob "SD.!b"
    base:
                    org     #6000-3
     
    VPage           equ     #01AF
    VConfig         equ     #00AF
     
    XOffsL          equ     #02AF
    XOffsH          equ     #03AF
     
    RAMPage3        equ     #13AF

    DMASAddrL       EQU     #1AAF
    DMASAddrH       EQU     #1BAF
    DMASAddrX       EQU     #1CAF
    DMADAddrL       EQU     #1DAF
    DMADAddrH       EQU     #1EAF
    DMADAddrX       EQU     #1FAF
    DMALen          EQU     #26AF
    DMACtrl         EQU     #27AF
    DMANum          EQU     #28AF
    DMAStatus       EQU     #27AF
    
    Page0           EQU     #10AF
    Page1           EQU     #11AF
    Page2           EQU     #12AF
    Page3           EQU     #13AF
    
    SrcPG	    EQU	  0x05
    DstPG	    EQU   0x20
    SrcAdr	    EQU	  FillDATA
    DstAdr	    EQU	  0x0000
     
    startCode
     jp dointro
     
dointro:

; 	суперкод
	
	ret
	
	MODULE	CopyDMA512

@CopyDMA512:     
    
	  ld   hl,SrcAddr
          ld   bc,DMASAddrH   
          out   (c),h     
          ld   bc,DMASAddrL  
          out   (c),l        
          ld   bc,DMADAddrX	; заполняем
          ld   a,SrcPG	   	;
          out   (c),a      ;
	  
          ld   hl,DestAddr 	  
          ld   bc,DMADAddrH   ;
	  out   (c),h      ;
          ld   bc,DMADAddrL   ;
          out   (c),l      ;
          ld   a,DstPG
	  out  (c),a
     
          ld   bc,DMALen  
          ld   a,0xff	   ;порциями по 512 байт
          out   (c),a
       
          ld   bc,DMANum    
          ld   a,0	   ; 1 порция
          out   (c),a
       
          ld   bc,DMACtrl   ;врубаем RAM->RAM
          ld   a,%00000001  ;%00000100-врубаем FILL->RAM
          out   (c),a
         
          ld   bc,DMAStatus   ;ждем окончания
.c1rl:    in   a,(c)
          or   a
          jr   nz,.c1rl
	  ret
	ENDMODULE
	
	MODULE	CopyDMA_512
; In:	HL = SrcPtr
;	DE = DstPtr
;	B  = SrcPg
;	C  = DstPg
;	A  = BurstNum

@CopyDMA_512:     
	push	af,bc
	ld	bc,DMASaddrL
	out	(c),l
	inc	b
	out	(c),h
	inc	b
	pop	hl
	out	(c),h
	inc	b
	out	(c),e
	inc	b
	out	(c),d
	inc	b
	out	(c),l
	out	(c),a
	ld	a,0xff
	out	(c),a
 .2	inc	b
	pop	af
	out	(c),a
	dec	b
	ld	a,%00000001
	out	(c),a
.wait:  in   a,(c)
        or   a
        jr   nz,.wait
	ret
	ENDMODULE
		
	
	align	2,0	; DMA работает только с четными адресами
@FillDATA:
	BLOCK	512,0    
    endCode:
     display /d,endCode-startCode
    ;       SAVESNA "sinedots.sna", startCode
        EMPTYTRD "sd.trd"
        SAVETRD "sd.trd","sd.C",startCode,endCode-startCode
        SAVETRD "sd.trd","boot.B",basb,base-basb

