;;#0FAF(4015)  Border.  .

;---------------------------------------
; TSConf examples
; (C) breeze/fishbone crew 2013
;---------------------------------------

        DEVICE ZXSPECTRUM128


 org $4000
basb:
 inchob "SD.!b"
base:
		org	#6000-3

VPage		equ	#01AF
VConfig		equ	#00AF

XOffsL		equ	#02AF
XOffsH		equ	#03AF

RAMPage3	equ	#13AF

startCode
 jp dointro
st1:incbin"st1.bin"
dointro:

 ld a,#20
 call cls


		LD	BC,VConfig    ;  : 360x288
		LD	A,%01000010
		LD	A,%11000010
		OUT	(C),A
;;-----------------------------------------
        ld a,$20
		LD	BC,VPage      ;  ,     #20
		OUT	(C),A

;; jp dotw
;------------mk palette
 ld bc,#0FAF;border colour
 xor a:out(c),a
;open FMAddr access from 0x0000
FMAddr     EQU #15AF
 ld bc, FMAddr
 ld a, 0x10;0x18 - if $8000
 out (c), a

;load CRAM
;.: gggBBbbb
;.: 0RRrrrGG
 ld hl,0:ld (0),hl
 ld de,2
 ld bc,510
 ldir
 ld de,0
 ld hl,mypalb
 ld bc,mypale-mypalb
 ldir

;close FMAddr
 ld bc, FMAddr
 xor a
 out (c), a


keflp:ei:halt

 ld hl,0,(hpos+1),de

pp3:ld de,00000
 ld h,st1/256
 ld l,e
 ld a,(hl)
 ld l,d
 add a,(hl)
 inc e,e
 dec d,d,d
 ld (pp3+1),de

 ld (kefd1+1),a

pp4:ld de,00000
 ld h,st1/256
 ld l,e
 ld a,(hl)
 ld l,d
 add a,(hl)
 dec e,e,e
 inc d,d,d,d
 ld (pp4+1),de

 ld (kefd2+1),a

;;- ld ixh,0
 ld ixl,$20;video page
 ld hl,$C000;
kefrens:
 push hl
;;- inc ixh
 ld h,st1/256
pp1:ld de,$0000
 ld l,d
 ld a,(hl)
 ld l,e
 add a,(hl)
 inc e,e
 dec d
 ld (pp1+1),de
 ld d,0,e,a
kefd1: ld hl,$8000
 add hl,de
 ld a,15
 ld de,kefbar1
 ex de,hl
lp0:ldi:dec a:jr nz,lp0
;-----------------------2nd bar
 ld h,st1/256
pp2:ld de,$0000
 ld l,d
 ld a,(hl)
 ld l,e
 add a,(hl)
 inc e,e,e
 inc d,d
 ld (pp2+1),de
 ld d,0,e,a
kefd2: ld hl,$8000
 add hl,de
hpos:ld de,0
 add hl,de
 inc de:ld (hpos+1),de
;;- ld e,ixh
;;- add hl,de

 ld a,15
 ld de,kefbar2
 ex de,hl
lp00:ldi:dec a:jr nz,lp00


;-------------------------- out buffer to videopage
		ld	bc,DMASAddrX	;
		ld	a,2;x		; x -    
		out	(c),a		;
		ld	hl,$8000;xxxx		;    
		ld	bc,DMASAddrH	;
		out	(c),h		;
		ld	bc,DMASAddrL	;
		out	(c),l		;
	
		ld	bc,DMADAddrX	;
		ld	a,ixl;;#20;;y		; y -    
		out	(c),a		;
		pop hl;;ld	hl,$C000;;yyyy		;     
		ld	bc,DMADAddrH	;
		out	(c),h		;
		ld	bc,DMADAddrL	;
		out	(c),l		;
	
		ld	bc,DMALen	;
		ld	a,255		;     (0- 2 ,1- 4 ,2- 6 6  .) .     255 - 512 
		out	(c),a
	
		ld	bc,DMANum	;  ,   0, .       ,  0
		ld	a,0
		out	(c),a

		ld	bc,DMACtrl	;
		ld	a,%00000001	;   RAM-RAM (0)0000(001),  
		out	(c),a		;

c1rl:	ld	bc,DMAStatus	; 
		in	a,(c)
		or	a
		jr	nz,c1rl

;	..        ,               
;	      , 0     .     0001h,     0000h
       inc h,h
       jr nz,skipnextvpage
       ld h,$C0
       inc ixl
skipnextvpage:
 ld a,ixl:cp $29:jp nz,kefrens
;; jr $
 ld (spback+1),sp
 ld sp, #81FF
 ld de,0

 dup 256
 push de
edup
spback:ld sp,0

;cnt:ld a,0:inc a:and 127:ld (cnt+1),a:or a:jr nz,skip_param
ppp1:ld hl,0
 inc h,h,h,h
 dec l,l,l
 ld (pp1+1),hl
 ld (ppp1+1),hl

ppp2:ld hl,0
 dec h
 inc l
 ld (pp2+1),hl
 ld (ppp2+1),hl

skip_param:
 jp keflp
mypalb:
; dw $0000,$280A,$300C,$3C0F,$4411,$4C13,$5415,$7FE0,$5415,$4C13,$4411,$3C0F,$300C,$280A,$03FF,$7FFF
 dw 0
 dw 1024*10+32*0+10;1----0RRrrrGG.gggBBbbb
 dw 1024*12+32*0+12;2
 dw 1024*14+32*0+14;3
 dw 1024*16+32*0+16;4
 dw 1024*18+32*0+18;5
 dw 1024*20+32*0+20;6
 dw 1024*31+32*31+0;7;;Yellow=R+G
;----------------------------------bar part 2
 dw 1024*0+32*10+10;8----0RRrrrGG.gggBBbbb
 dw 1024*0+32*12+12;9
 dw 1024*0+32*14+14;10
 dw 1024*0+32*16+16;11
 dw 1024*0+32*18+18;12
 dw 1024*0+32*20+20;13
 dw 1024*31+32*0+31;14
mypale:

kefbar1: db 01,01,02,03,04,05,06,07,06,05,04,03,02,01,01
kefbar2: db 08,08,09,10,11,12,13,14,13,12,11,10,09,08,08
cls:
DMASAddrL       EQU	#1AAF
DMASAddrH       EQU	#1BAF
DMASAddrX       EQU	#1CAF
DMADAddrL       EQU	#1DAF
DMADAddrH       EQU	#1EAF
DMADAddrX       EQU	#1FAF
DMALen          EQU	#26AF
DMACtrl         EQU	#27AF
DMANum          EQU	#28AF
DMAStatus       EQU	#27AF
Page0           EQU	#10AF
Page1           EQU	#11AF
Page2           EQU	#12AF
Page3           EQU	#13AF

clear_page   ld   bc,Page0   ; 
cp1:      ld   a,$20;;33      ;33
;      out   (c),a      ; 0 
      ld   hl,0      ;  0000
      ld   (0),hl


;      ld   bc,DMASAddrX   ;
;cp2:      ld   a,$20;;33      ; 
;      out   (c),a      ; 
;      ld   hl,0      ; 33 
;      ld   bc,DMASAddrH   ;
;      out   (c),h      ;
;      ld   bc,DMASAddrL   ;
;      out   (c),l      ;
;
;      ld   bc,DMADAddrX   ;
;      ld   a,128      ; 128 
;      out   (c),a      ;
;      ld   hl,0      ; 0  ( )
;      ld   bc,DMADAddrH   ;
;      out   (c),h      ;
;      ld   bc,DMADAddrL   ;
;      out   (c),l      ;
;   
;      ld   bc,DMALen   ;  512  (0-2,255-512)
;      ld   a,255
;      out   (c),a
;   
;      ld   bc,DMANum   ;256 
;      ld   a,255
;      out   (c),a
;   
;      ld   bc,DMACtrl   ; FILL->RAM
;      ld   a,%00000100
;      out   (c),a
;      
;      ld   bc,DMAStatus   ; 
;c1rl      in   a,(c)
;      or   a
;      jr   nz,c1rl
;      ret

    ld bc,#13AF
;;    ld a,#20
    out (c),a
    ld hl,0
    ld (#c000),hl
    ld bc,#20af
    ld a,6 
    out (c),a
    ld bc,#1AAF
    ld a,$20;;(memv+1)
    ld h,a
    ld l,0
;    ld hl,#2000
    out (c),l;DMASAddrL       EQU	#1AAF
    inc b
    out (c),l;DMASAddrH       EQU	#1BAF
    inc b
    out (c),h;DMASAddrX       EQU	#1CAF
    inc b
    out (c),l;DMADAddrL       EQU	#1DAF
    inc b
    out (c),l;DMADAddrH       EQU	#1EAF
    inc b
    out (c),h;DMADAddrX       EQU	#1FAF
    ld b,#26
    dec l
;;    ld a,8*8
    out (c),l;DMALen          EQU	#26AF
    inc b
    inc b
    ld a,199;;125+3;;
    out (c),a;;l;DMANum          EQU	#28AF
    dec b
    ld a,%00000100; FILL->RAM
    out (c),a;DMACtrl         EQU	#27AF
waitdma1:
    inf
    jp m,waitdma1
    ld b,#26
    ld a,8*8
    out (c),a;l;DMALen          EQU	#26AF
    inc b
    inc b
    out (c),l;DMANum          EQU	#28AF
    dec b
    ld a,%00000100
    out (c),a
waitdma2:
    inf
    jp m,waitdma2
 ret
endCode:
 display /d,endCode-startCode
;	SAVESNA "sinedots.sna", startCode
    EMPTYTRD "sd.trd"
    SAVETRD "sd.trd","sd.C",startCode,endCode-startCode
    SAVETRD "sd.trd","boot.B",basb,base-basb
